c
c ---------------------------------------------------------------
c
      subroutine bb80ll(card,xlat,xlon)
ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Subroutine for extracting the latitude and
c - longitude from a *80* blue book record
c - Force:  -90 <= xlat <=  +90
c -           0 <= xlon <= +360
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      character*80 card
      character*80 SCCSID

      integer*4 deglat,minlat,seclat
      integer*4 deglon,minlon,seclon
      character*1 lathem,lonhem
 
      real*8 xlat,xlon,latsc,lonsc
      integer*4 ival,iflag
      real*8 xval

      SCCSID="@(#)bb80ll.f	1.1	2004/01/16 NGS"

      
c - The following line doesn't work with older FORTRAN compilers
c     read(card,1)deglat,minlat,seclat,lathem,
c    *            deglon,minlon,seclon,lonhem
    1 format(44x,i2,i2,i7,a1,i3,i2,i7,a1)

      call val(card(45:46),iflag,ival,xval)
      deglat = ival
      call val(card(47:48),iflag,ival,xval)
      minlat = ival
      call val(card(49:55),iflag,ival,xval)
      seclat = ival
      lathem = card(56:56)

      call val(card(57:59),iflag,ival,xval)
      deglon = ival
      call val(card(60:61),iflag,ival,xval)
      minlon = ival
      call val(card(62:68),iflag,ival,xval)
      seclon = ival
      lonhem = card(69:69)
      

      if(lathem.eq.'N')then
        latsc = +1
      elseif(lathem.eq.'S')then
        latsc = -1
      else
        xlat = -999.d0
        xlon = -999.d0
        return
      endif

      if(lonhem.eq.'E')then
        lonsc = +1
      elseif(lonhem.eq.'W')then
        lonsc = -1
      else
        xlat = -999.d0
        xlon = -999.d0
        return
      endif

      xlat = latsc*(deglat + (minlat/60.d0) + (seclat/3600.d0/1d5))
      xlon = lonsc*(deglon + (minlon/60.d0) + (seclon/3600.d0/1d5))

      if(xlon.lt.0)xlon = xlon + 360.d0

      if(xlat.lt.-90 .or. xlat.gt.+90 .or.
     *   xlon.lt.000 .or. xlon.gt.360) then
        xlat = -999.d0
        xlon = -999.d0
      endif
      return
      end
c
c
c
