* /ngslib/source/Geoid/Flib/SCCS/s.getgrd.f
* "@(#)getgrd.f 	1.25	2009/09/22 NGS"
* ---------------------------------------------------------------
* See sccs comments for modification history
* ---------------------------------------------------------------

      subroutine getgrd(imodel,dirnam,IS_SUBR, nfiles,fnam,lin,nff)
*---------------------------------------------------------------------
* Subroutine "get (geoid) grids"
* Fills a vector with the file names of the gridded input data,
* and open all files that can be found in the given directory.
* Additional geoid models may be added as developed.
*  in - imodel  : integer key to specific geoid model
*  in - dirnam  : directory location of binary geoid model files
*               : special- "ngs" is key to use NGS network files
*  in - IS_SUBR : run as subroutine: false=0;  true=1; (c std notation)
*  out- nfiles  : number of binary files used for the specific geoid model
*  out- fnam    : array (vector of character vectors) of geoid model filenames
*  out- lin     : vector of file unit numbers  (type = long int)
*               : of geoid model files opened in this subroutine
*  out- nff     : "Number of Files Found" and --successfully opened--
*---------------------------------------------------------------------
      implicit none
      integer       imodel
      character*256 dirnam
      integer       IS_SUBR
      integer       nfiles
      character*256 fnam(50)
      integer       lin(50)
      integer       nff

      character*80  SCCSID
      character*256 b256
      character*4   suf 
      character*2   cval
      character*40  b40

      integer       ios(50)
      integer       ii
      integer       ilen
      integer       lnblnk

ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Initialize variables
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      common /grid3/ ios
      SCCSID="@(#)getgrd.f 	1.25	2009/09/22 NGS"

      b40 = '                                        '
      b256=b40//b40//b40//b40//b40//b40//'                '

c - set data filenames to blanks
      do 10 ii=1,50
        fnam(ii) = b256
   10 continue


      if (dirnam.eq.b256) then
          ilen   = 0

c ----- Not Yet Implemented
c ----- BEGIN NGS network file locations

cc      elseif (dirnam(1:3).eq.'ngs') then
cc        if    (imodel.eq.1) then
cc          dirnam = '/ngslib/data/Geoid/Geoid99/'
cc          ilen   = lnblnk(dirnam)
cc        elseif(imodel.eq.2) then
cc          dirnam = '/ngslib/data/Geoid/G99sss/'
cc          ilen   = lnblnk(dirnam)
cc        elseif(imodel.eq.3) then
cc          dirnam = '/ngslib/data/Geoid/Geoid03/'
cc          ilen   = lnblnk(dirnam)
cc        elseif(imodel.eq.4) then
cc          dirnam = '/ngslib/data/Geoid/USGG2003/'
cc          ilen   = lnblnk(dirnam)
cc        elseif(imodel.eq.9) then
cc          dirnam = '/ngslib/data/Geoid/Geoid99/'
cc          ilen   = lnblnk(dirnam)
cc        endif
c ----- END   NGS network file locations

      else
        ilen = lnblnk(dirnam)
      endif

  109 format(i2.2)

ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Establish the suffix of files to be opened
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      suf = '.bin'


cccccccccccccccccccccccccccccccccccccc
c - The GEOID99 file names
cccccccccccccccccccccccccccccccccccccc
      if(    imodel.eq.1) then
        nfiles = 14

c - First 8 files are CONUS
        do 1101 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 'g1999u'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g1999u'//cval//suf
          endif
 1101   continue

c - Next 4 files are ALASKA
        do 1102 ii=9,12
          write(cval,109) ii-8
          if (ilen.eq.0) then
            fnam(ii) =                 'g1999a'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g1999a'//cval//suf
          endif
 1102   continue

c - Next 1 file is HAWAII
        do 1103 ii=13,13
          write(cval,109) ii-12
          if (ilen.eq.0) then
            fnam(ii) =                 'g1999h'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g1999h'//cval//suf
          endif
 1103   continue

c - Next 1 file is PR/VI
        do 1104 ii=14,14
          write(cval,109) ii-13
          if (ilen.eq.0) then
            fnam(ii) =                 'g1999p'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g1999p'//cval//suf
          endif
 1104   continue


cccccccccccccccccccccccccccccccccccccc
c - The G99SSS file names
cccccccccccccccccccccccccccccccccccccc
      elseif(imodel.eq.2) then
        nfiles = 8

c - First 8 files are CONUS
        do 1201 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 's1999u'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s1999u'//cval//suf
          endif
 1201   continue


cccccccccccccccccccccccccccccccccccccc
c - The GEOID03 file names
cccccccccccccccccccccccccccccccccccccc
      elseif(imodel.eq.3) then
        nfiles = 14
c - First 8 files are CONUS
        do 1301 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 'g2003u'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2003u'//cval//suf
          endif
 1301   continue

c - Next 4 files are ALASKA
        do 1302 ii=9,12
          write(cval,109) ii-8
          if (ilen.eq.0) then
            fnam(ii) =                 'g2003a'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2003a'//cval//suf
          endif
 1302   continue

c - Next 1 file is HAWAII
        do 1303 ii=13,13
          write(cval,109) ii-12
          if (ilen.eq.0) then
            fnam(ii) =                 'g2003h'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2003h'//cval//suf
          endif
 1303   continue

c - Next 1 file is PR/VI
        do 1304 ii=14,14
          write(cval,109) ii-13
          if (ilen.eq.0) then
            fnam(ii) =                 'g2003p'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2003p'//cval//suf
          endif
 1304   continue


cccccccccccccccccccccccccccccccccccccc
c - The USGG2003 file names
cccccccccccccccccccccccccccccccccccccc
      elseif(imodel.eq.4) then
        nfiles = 14
c - First 8 files are CONUS
        do 1401 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 's2003u'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2003u'//cval//suf
          endif
 1401   continue

c - Next 4 files are ALASKA
        do 1402 ii=9,12
          write(cval,109) ii-8
          if (ilen.eq.0) then
            fnam(ii) =                 's2003a'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2003a'//cval//suf
          endif
 1402   continue

c - Next 1 file is HAWAII
        do 1403 ii=13,13
          write(cval,109) ii-12
          if (ilen.eq.0) then
            fnam(ii) =                 's2003h'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2003h'//cval//suf
          endif
 1403   continue

c - Next 1 file is PR/VI
        do 1404 ii=14,14
          write(cval,109) ii-13
          if (ilen.eq.0) then
            fnam(ii) =                 's2003p'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2003p'//cval//suf
          endif
 1404   continue


cccccccccccccccccccccccccccccccccccccc
c - The GEOID06 file names
cccccccccccccccccccccccccccccccccccccc
      elseif(imodel.eq.5) then
        nfiles = 4

ccbillw - conus goes here
ccbillw - Next 4 files are ALASKA
c - First 4 files are ALASKA
        do 1502 ii=1,4
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 'g2006a'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2006a'//cval//suf
          endif
 1502   continue


cccccccccccccccccccccccccccccccccccccc
c - The USGG2009 file names
cccccccccccccccccccccccccccccccccccccc
      elseif(imodel.eq.6) then
        nfiles =  16
c - First 8 files are CONUS
        do 1601 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 's2009u'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009u'//cval//suf
          endif
 1601   continue

c - Next 4 files are ALASKA
        do 1602 ii=9,12
          write(cval,109) ii-8
          if (ilen.eq.0) then
            fnam(ii) =                 's2009a'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009a'//cval//suf
          endif
 1602   continue
 
c - Next 1 file is HAWAII
        do 1603 ii=13,13
          write(cval,109) ii-12
          if (ilen.eq.0) then
            fnam(ii) =                 's2009h'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009h'//cval//suf
          endif
 1603   continue
 
c - Next 1 file is GUAM
        do 1604 ii=14,14
          write(cval,109) ii-13
          if (ilen.eq.0) then
            fnam(ii) =                 's2009g'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009g'//cval//suf
          endif
 1604   continue

c - Next 1 file is SAMOA
        do 1605 ii=15,15
          write(cval,109) ii-14
          if (ilen.eq.0) then
            fnam(ii) =                 's2009s'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009s'//cval//suf
          endif
 1605   continue

c - Next 1 file is PR/VI
        do 1606 ii=16,16
          write(cval,109) ii-15
          if (ilen.eq.0) then
            fnam(ii) =                 's2009p'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'s2009p'//cval//suf
          endif
 1606   continue


cccccccccccccccccccccccccccccccccccccc
c - The GEOID09 file names
cccccccccccccccccccccccccccccccccccccc
      elseif(imodel.eq.7) then
C        nfiles = 16         Waiting for PRVI
        nfiles = 15
c - First 8 files are CONUS
        do 1701 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009u'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009u'//cval//suf
          endif
 1701   continue

cc - Next 4 files are ALASKA
        do 1702 ii=9,12
          write(cval,109) ii-8
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009a'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009a'//cval//suf
          endif
 1702   continue
c 
c - Next 1 file is HAWAII
        do 1703 ii=13,13
          write(cval,109) ii-12
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009h'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009h'//cval//suf
          endif
 1703   continue

c - Next 1 file is GUAM - NORTHERN MARIANAS
        do 1704 ii=14,14
          write(cval,109) ii-13
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009g'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009g'//cval//suf
          endif
 1704   continue

cc - Next 1 file is SAMOA
        do 1705 ii=15,15
          write(cval,109) ii-14
          if (ilen.eq.0) then
            fnam(ii) =                 'g2009s'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'g2009s'//cval//suf
          endif
 1705   continue

c 
c c - Next 1 file is PR/VI
c         do 1706 ii=16,16
c           write(cval,109) ii-15
c           if (ilen.eq.0) then
c             fnam(ii) =                 'g2009p'//cval//suf
c           else
c             fnam(ii) = dirnam(1:ilen)//'g2009p'//cval//suf
c           endif
c  1706   continue
c 

cccccccccccccccccccccccccccccccccccccc
c - Experimental Geoid: XXUSG
cccccccccccccccccccccccccccccccccccccc
      elseif(imodel.eq.9) then
        nfiles = 8

c - First 8 files are CONUS
        do 1901 ii=1,8
          write(cval,109) ii
          if (ilen.eq.0) then
            fnam(ii) =                 'xxusgu'//cval//suf
          else
            fnam(ii) = dirnam(1:ilen)//'xxusgu'//cval//suf
          endif
 1901   continue

      endif

ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Now open all the files
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      do 201 ii=1,nfiles 
cDEBUG        write(6,205) fnam(ii)(1:(ilen+16) )
        open(lin(ii),file=fnam(ii),status='old',form='unformatted',
     *       access='direct',recl=4,iostat=ios(ii))
        if(ios(ii).eq.0)then
          if (IS_SUBR .ne. 0) then
            write(6,203) fnam(ii)(1:(ilen+16) )
          endif
        endif
  201 continue
  203 format(' *** Opening File: ',A)
  205 format(' Filename fnam(ii) = ',A)


ccccccccccccccccccccccccccccccccccccccccccccccccccc
c - Check and see if at least ONE file was opened,
c - and make a count of how many WERE opened.
c - Abort if we find no geoid files.
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      nff = 0
      do 207 ii=1,nfiles
        if(ios(ii).eq.0) nff = nff + 1
  207 continue

      if(nff.eq.0) then
        write(6,209) dirnam, imodel
        stop
      endif

  209 format(' *** ERROR(209):  No files found -- aborting',/
     *       ' input directory : ',A,/,
     *       ' input model code: ',I3)

      end

